Loading...
Searching...
No Matches
Sip_reason

## Data Structures

struct | sip_reason_s
| Structure for Reason header field. More...

## Macros

#define | sip_reason(sip)
| Access a SIP Reason header structure sip_reason_t from sip_t.
#define | SIP_REASON_INIT()
| Initializer for structure sip_reason_t.
#define | SIPTAG_REASON(x)
| Tag list item for pointer to a Reason header structure sip_reason_t.
#define | SIPTAG_REASON_REF(x)
| Tag list item for reference to a Reason header pointer.
#define | SIPTAG_REASON_STR(s)
| Tag list item for string with Reason header value.
#define | SIPTAG_REASON_STR_REF(x)
| Tag list item for reference to a Reason header string.

## Typedefs

typedef struct sip_reason_s | sip_reason_t
| @

## Functions

issize_t | sip_reason_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Reason header.
issize_t | sip_reason_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Reason header.
sip_reason_t * | sip_reason_init (sip_reason_t x[1])
| Initialize a structure sip_reason_t.
int | sip_is_reason (sip_header_t const *header)
| Test if header object is instance of sip_reason_t.
sip_reason_t * | sip_reason_dup (su_home_t *home, sip_reason_t const *hdr))
| Duplicate a list of Reason header header structures sip_reason_t.
sip_reason_t * | sip_reason_copy (su_home_t *home, sip_reason_t const *hdr))
| Copy a list of Reason header header structures sip_reason_t.
sip_reason_t * | sip_reason_make (su_home_t *home, char const *s))
| Make a Reason header structure sip_reason_t.
sip_reason_t * | sip_reason_format (su_home_t *home, char const *fmt,...)))
| Make a Reason header from formatting result.

## Variables

msg_hclass_t | sip_reason_class []
| Header class for Reason header.
tag_typedef_t | siptag_reason
| Tag for Reason header object.
tag_typedef_t | siptag_reason_str
| Tag for string with Reason header value.

## Detailed Description

## Macro Definition Documentation

## SIP_REASON_INIT

#define SIP_REASON_INIT | ( |  | ) |

Initializer for structure sip_reason_t.

A static sip_reason_t structure for Reason header must be initialized with the SIP_REASON_INIT() macro. For instance,

sip_reason_t sip_reason = SIP_REASON_INIT;
sip_reason
#define sip_reason(sip)
Access a SIP Reason header structure sip_reason_t from sip_t.
Definition sip_protos.h:12983
SIP_REASON_INIT
#define SIP_REASON_INIT()
Initializer for structure sip_reason_t.
Definition sip_protos.h:13000
sip_reason_t
struct sip_reason_s sip_reason_t
@
Definition sip.h:172

## SIPTAG_REASON

#define SIPTAG_REASON | ( |  | x | ) |

Tag list item for pointer to a Reason header structure sip_reason_t.

The SIPTAG_REASON() macro is used to include a tag item with a pointer to a sip_reason_t structure in a tag list.

Parameters

  x | pointer to a sip_reason_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_REASON_REF().

## SIPTAG_REASON_STR

#define SIPTAG_REASON_STR | ( |  | s | ) |

Tag list item for string with Reason header value.

The SIPTAG_REASON_STR() macro is used to include a tag item with a string containing value of a sip_reason_t header in a tag list.

Parameters

  s | pointer to a string containing Reason header value, or NULL.

The string in SIPTAG_REASON_STR() can be converted to a sip_reason_t header structure by giving the string s has second argument to function sip_reason_make().

The corresponding tag taking reference parameter is SIPTAG_REASON_STR_REF().

## Typedef Documentation

## sip_reason_t

typedef struct sip_reason_s sip_reason_t

@

The Reason header is used to indicate why a SIP request was issued or why a provisional response was sent. It can be used with HRPF scenarios. It is defined in RFC 3326 as follows:

Reason = "Reason" HCOLON reason-value *(COMMA reason-value)
reason-value = protocol *(SEMI reason-params)
protocol = "SIP" / "Q.850" / token
reason-params = protocol-cause / reason-text
/ reason-extension
protocol-cause = "cause" EQUAL cause
cause = 1*DIGIT
reason-text = "text" EQUAL quoted-string
reason-extension = generic-param
DIGIT
#define DIGIT

The parsed Reason header is stored in sip_reason_t structure.

The structure sip_reason_t contains representation of SIP Reason header.

The sip_reason_t is defined as follows:

typedef struct sip_reason_s
{
sip_common_t re_common[1]; // Common fragment info
sip_reason_t *re_next; // Link to next <reason-value>
char const *re_protocol; // Protocol
msg_param_t const *re_params; // List of reason parameters
char const *re_cause; // Value of cause parameter
char const *re_text; // Value of text parameter
} sip_reason_t;
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_reason_s
Structure for Reason header field.
Definition sip.h:668
sip_reason_s::re_cause
char const * re_cause
Value of cause parameter.
Definition sip.h:673
sip_reason_s::re_common
sip_common_t re_common[1]
Common fragment info.
Definition sip.h:669
sip_reason_s::re_params
msg_param_t const * re_params
List of reason parameters.
Definition sip.h:672
sip_reason_s::re_next
sip_reason_t * re_next
Link to next.
Definition sip.h:670
sip_reason_s::re_protocol
char const * re_protocol
Protocol.
Definition sip.h:671
sip_reason_s::re_text
char const * re_text
Value of text parameter.
Definition sip.h:674

## Function Documentation

## sip_is_reason()

int sip_is_reason | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_reason_t.

Check if the header class is an instance of Reason header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header reason
  0 | (false) otherwise

## sip_reason_copy()

sip_reason_t * sip_reason_copy | ( | su_home_t * | home,
|  | sip_reason_t const * | hdr )

inline

Copy a list of Reason header header structures sip_reason_t.

The function sip_reason_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  reason = sip_reason_copy(home, sip->sip_reason);
  sip_reason_copy
  sip_reason_t * sip_reason_copy(su_home_t *home, sip_reason_t const *hdr))
  Copy a list of Reason header header structures sip_reason_t.
  Definition sip_protos.h:13130

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_reason_dup()

sip_reason_t * sip_reason_dup | ( | su_home_t * | home,
|  | sip_reason_t const * | hdr )

inline

Duplicate a list of Reason header header structures sip_reason_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  reason = sip_reason_dup(home, sip->sip_reason);
  sip_reason_dup
  sip_reason_t * sip_reason_dup(su_home_t *home, sip_reason_t const *hdr))
  Duplicate a list of Reason header header structures sip_reason_t.
  Definition sip_protos.h:13087

Returns
  A pointer to the newly duplicated sip_reason_t header structure, or NULL upon an error.

## sip_reason_format()

sip_reason_t * sip_reason_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Reason header from formatting result.

Make a new sip_reason_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_reason_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_reason_init()

sip_reason_t * sip_reason_init | ( | sip_reason_t | x[1] | ) |

inline

Initialize a structure sip_reason_t.

An sip_reason_t structure for Reason header can be initialized with the sip_reason_init() function/macro. For instance,

sip_reason_t sip_reason;
sip_reason_init(&sip_reason);
sip_reason_init
sip_reason_t * sip_reason_init(sip_reason_t x[1])
Initialize a structure sip_reason_t.
Definition sip_protos.h:13018

## sip_reason_make()

sip_reason_t * sip_reason_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Reason header structure sip_reason_t.

The function sip_reason_make() makes a new sip_reason_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_reason_t header structure, or NULL upon an error.

## Variable Documentation

## sip_reason_class

msg_hclass_t sip_reason_class[]

extern

Header class for Reason header.

The header class sip_reason_class defines how a SIP Reason header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_reason_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.